﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@model Toyota.Common.Web.MVC.ModelHolder
@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}
<style type="text/css">
    #StatusOption .dxic, #StatusOption_I {
        background-color: #F6CECE !important;
    }

    #DeliveryTypeOption .dxic, #LogisticPartnerOption .dxic, #PO_NO .dxic, #RouteOption .dxic, #DELIVERY_NO .dxic, #ROUTE_DATE .dxic, #ROUTE_DATE_TO .dxic, #DeliveryTypeOption_I, #LogisticPartnerOption_I, #PO_NO_I, #RouteOption_I, #DELIVERY_NO_I, #ROUTE_DATE_I, #ROUTE_DATE_TO_I {
        background-color: #F5F6CE !important;
    }

    .btnOkeh {
        float: right;
        margin-right: 5px;
        height: 5px !important;
    }

        .btnOkeh .dxbButton_IPPCSBlue .dxb {
            padding: 1px 3px 1px !important;
        }

            .btnOkeh .dxbButton_IPPCSBlue .dxb SPAN {
                height: 4px;
            }

            .btnOkeh .dxbButton_IPPCSBlue .dxb SPAN {
                font-size: 9px;
            }
</style>
<script type="text/javascript">
    $(document).ready(function()
    {
        GridLogisticPartnerOption.SetHeight(-145);

        $('#toggleDetail').hide();
        $('#juju').hide();
        ROUTE_DATE.SetText("");
        ROUTE_DATE_TO.SetText("");
        GridDeliveryTypeOption.SetHeight(-175);
        GridStatusOption.SetHeight(-50);

        $('#PO_NO_I').keypress(function(e) {
            //console.log(e.keyCode);
            if(e.keyCode == 8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40){
                //console.log(e.keyCode);
            }
            else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9]/)) {
                e.preventDefault();
            }
        });

        $('#DELIVERY_NO_I').keypress(function(e){
            if(e.keyCode == 8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40){
                //console.log(e.keyCode);
            }
            else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9]/)) {
                e.preventDefault();
            }
        });

    });
    var isApprove = "F";
    var isCancel = "F";
    var approveProcess = false;
    var cancelProcess = false;
    var DeliveryNo = "";
    var IsDownload = "no";
    var toggled = 0;
    var CheckAllCount = 0;
    var CheckAllCountChange = 0;
    var parameterList = "";
    function AddRoute(s, e) {
        popupnew.SetHeaderText('Add Service Acceptance ');
        popupnew.Show();
    }

    function SearchData(s, e) {
        var a = DELIVERY_NO.GetText();
        var b = PO_NO.GetText();
        var err=0;
        if(a.match(/[^A-Za-z0-9_/-]/)!=null)
        {
            err = 1;
        }

        if(b.match(/[^A-Za-z0-9_/-]/)!=null)
        {
            err = 1;
        }


        if(err == 1)
        {
            $.msgBox({ title: "Warning", content: "Only can be use number or text"});
        }
        else
        {

            if(StatusOption.GetText()=="")
            {
                dialog.SetHeaderText('Error');
                $('#icono').html('<img width="32" src="@Url.Content("~/Content/images/error_icon.png")" />');
                message.textContent = "Status field can't be empty";

                //dialog.Show();
                $.msgBox({ title: "Warning", type:"alert", content: "Status field can't be empty" });
            }else
            {

                if(ROUTE_DATE.GetValue() > ROUTE_DATE_TO.GetValue())
                {
                    $.msgBox({ title: "Warning", type:"alert", content: "FROM DATE cannot be greater than TO DATE" });
                }
                else if(ROUTE_DATE_TO.GetText()!="")
                {
                    if(ROUTE_DATE.GetText()=="")
                    {
                        $.msgBox({ title: "Warning", type:"alert", content: "You cannot left FROM DATE empty while TO DATE filled" });
                    }
                    else
                    {
                        IsDownload = "no";
                        GridServiceAcceptance.ClearFilter();
                    }
                }
                else
                {
                    IsDownload = "no";
                    GridServiceAcceptance.ClearFilter();
                }

            }
        }
        err = 0;

    }

    function OnBeginCallbackGrid(s, e) {
        btnDownload.SetEnabled(false);
        btnApprove.SetEnabled(false);
        btnCancel.SetEnabled(false);
        btnToggle.SetEnabled(false);
        btnSearch.SetEnabled(false);
        btnClear.SetEnabled(false);
        e.customArgs["DeliveryNo"] = DELIVERY_NO.GetText();
        e.customArgs["DeliveryType"] = DeliveryTypeOption.GetText();
        e.customArgs["LogisticPartner"] = LogisticPartnerOption.GetText();
        e.customArgs["Route"] = RouteOption.GetText();
        e.customArgs["Status"] = StatusOption.GetText();
        e.customArgs["IsDownload"] = IsDownload;
        e.customArgs["RouteDate"] = ROUTE_DATE.GetText();
        e.customArgs["RouteDateTo"] = ROUTE_DATE_TO.GetText();
        e.customArgs["PoNo"] = PO_NO.GetText();
        e.customArgs["visible"] = GridServiceAcceptance.columns[12].visible;

        //console.log(e.customArgs["visible"]);
    }

    function OnEndCallbackGrid(s, e) {
        btnDownload.SetEnabled(true);
        btnApprove.SetEnabled(true);
        btnCancel.SetEnabled(true);
        btnToggle.SetEnabled(true);
        btnSearch.SetEnabled(true);
        btnClear.SetEnabled(true);

        if(GridServiceAcceptance.GetSelectedRowCount()!=GridServiceAcceptance.cpVisibleRowCount)
        {
            CheckAll.SetValue(false);
        }

        if (isApprove == "T")
        {
            isApprove = "F";
            getDeliveryNo();
        }

        if (isCancel == "T")
        {
            isCancel = "F";
            getDeliveryNo();
        }
    }


    function DownloadData(s, e) {
        var a = DELIVERY_NO.GetText();
        var b = PO_NO.GetText();
        var err=0;
        if(a.match(/[^A-Za-z0-9_/-]/)!=null)
        {
            err = 1;
        }

        if(b.match(/[^A-Za-z0-9_/-]/)!=null)
        {
            err = 1;
        }


        if(StatusOption.GetText()=="")
        {

            $.msgBox({ title: "Warning", type:"alert", content: "Status field can't be empty" });
        }
        else
        {
            if(ROUTE_DATE_TO.GetText()!="")
            {
                if(ROUTE_DATE.GetText()=="")
                {
                    $.msgBox({ title: "Warning", type:"alert", content: "You cannot left FROM DATE empty while TO DATE filled" });
                }
                else
                {

                    if(err == 1)
                    {
                        $.msgBox({ title: "Warning", content: "Only can be use number or text"});
                    }
                    else
                    {
                        IsDownload = "yes";
                        BeginCallbackDownload(s, e);
                    }
                    err = 0;
                }
            }
            else
            {
                if(err == 1)
                {
                    $.msgBox({ title: "Warning", content: "Only can be use number or text"});
                }
                else
                {
                    IsDownload = "yes";
                    BeginCallbackDownload(s, e);
                }
                err = 0;
            }

        }
    }


    function BeginCallbackDownload(s, e) {

        $.fileDownload("D31301/DownloadServiceAcceptance/", {
            data: {
                DELIVERY_NO: DELIVERY_NO.GetText(),
                DELIVERY_TYPE: DeliveryTypeOption.GetText(),
                LP_CD: LogisticPartnerOption.GetText(),
                ROUTE: RouteOption.GetText(),
                STATUS: StatusOption.GetText(),
                ROUTE_DATE: ROUTE_DATE.GetText(),
                ROUTE_DATE_TO: ROUTE_DATE_TO.GetText(),
                PO_NO: PO_NO.GetText(),
                colDeliveryNo : GridServiceAcceptance_DXFREditorcol1.GetText(),
                colDeliveryType : GridServiceAcceptance_DXFREditorcol2.GetText(),
                colLPCode : GridServiceAcceptance_DXFREditorcol4.GetText(),
                colLPName : GridServiceAcceptance_DXFREditorcol5.GetText(),
                colRouteRate : GridServiceAcceptance_DXFREditorcol6.GetText(),
                colPickupDate : GridServiceAcceptance_DXFREditorcol7.GetText(),
                colStatus : GridServiceAcceptance_DXFREditorcol8.GetText(),
                colSANote : GridServiceAcceptance_DXFREditorcol9.GetText(),
                colArrival : GridServiceAcceptance_DXFREditorcol11.GetText(),
                colDeparture : GridServiceAcceptance_DXFREditorcol12.GetText(),
                colPONo : GridServiceAcceptance_DXFREditorcol13.GetText()
                /*,
                colMatDocPosting : GridServiceAcceptance_DXFREditorcol15.GetText(),
                colPostingDate : GridServiceAcceptance_DXFREditorcol16.GetText(),
                colPostingPic : GridServiceAcceptance_DXFREditorcol17.GetText(),
                colInvNo : GridServiceAcceptance_DXFREditorcol19.GetText(),
                colInvDate : GridServiceAcceptance_DXFREditorcol20.GetText(),
                colInvPic : GridServiceAcceptance_DXFREditorcol21.GetText(),
                colMatDocCancel : GridServiceAcceptance_DXFREditorcol23.GetText(),
                colCancelDate : GridServiceAcceptance_DXFREditorcol24.GetText(),
                colCancelPic : GridServiceAcceptance_DXFREditorcol25.GetText()*/
            },
            successCallback: function (result) {
                //GoodsReceiptInquiryProgressPopup.Hide();
            },
            failCallback: function (result) {
                //GoodsReceiptInquiryProgressPopup.Hide();

                alert("Error On Download Service Acceptance Data.");
            }
        });
    }


    function ClearItem(s, e) {

        OIHRouteOption.SetText('');
        PartGridView.ClearFilter();
    }

    function CancelAddNew(s, e) {
        RouteCodex.SetValue("");
        RouteNamex.SetValue("");


        popupnew.Hide();
    }

    function BeginCallbackAddNew(s, e) {
        if (RouteCodex.GetText()=="" || RouteNamex.GetText() =="")
        {
            //alert("Some Field Must To Be Fill, (*) is Required");
            $.msgBox({ title: "error", type:"error", content: "Some Field Must To Be Fill, (*) is Required" });
        }
        else
        {
            $.ajax(
              {
                  type: "POST",
                  url: "@Url.Content("~/RouteMaster/AddNewPart")",
                  data:
                  {

                      routeCode : RouteCodex.GetText(),
                      routeName : RouteNamex.GetText()

                  },
                  success: function (result) {
                      //alert(result);
                      RouteCodex.SetText("");
                      RouteNamex.SetText("") ;
                      popupnew.Hide();

                      GridServiceAcceptance.PerformCallback();
                  },
                  error: function (result) {
                      //alert("Error when update data");
                      $.msgBox({ title: "error", type:"error", content: "Error when update data" });
                  }
              });
        }
    }



    function ClearGrid(){
        ROUTE_DATE.SetText("");
        ROUTE_DATE_TO.SetText("");
        DELIVERY_NO.SetText("");
        PO_NO.SetText("");
        juju.SetText("");
        StatusOption.SetText("");
        RouteOption.SetText("");
        DeliveryTypeOption.SetText("");
        LogisticPartnerOption.SetText("");
        //StatusOption.SetText("");
        GridServiceAcceptance.ClearFilter();
        GridStatusOption.UnselectAllRowsOnPage();
        GridRouteOption.UnselectAllRowsOnPage();
        GridDeliveryTypeOption.UnselectAllRowsOnPage();
        GridLogisticPartnerOption.UnselectAllRowsOnPage();
    }



    function GetSelectedItemsText(items)
    {
        var texts = [];
        var textSeparator = ",";
        for (var i = 0; i < items.length; i++){
            if (items[i] != ''){
                texts.push(items[i].trim());
            }
        }
        DeliveryNo = texts.join(textSeparator);
        console.log(DeliveryNo);
    }

    function GetSelectedFieldValuesCallback(v)
    {
        //console.log(v);
        GetSelectedItemsText(v);
    }

    /*function CheckChange(s, e) {
        if (CheckAll.GetChecked())
        {
            GridServiceAcceptance.SelectRows();
        }
        else
        {
            GridServiceAcceptance.UnselectRows();
        }

       CheckAllCount = GridServiceAcceptance.cpVisibleRowCount
       CheckAllCountChange = GridServiceAcceptance.GetSelectedRowCount();

    }
    */
    /* function SelectionChange(s, items)
     {
         s.GetSelectedFieldValues(GridServiceAcceptance.cpKeyfield, GetSelectedFieldValuesCallback);
     }
     */
    function SelectionChange(s,e){
        //s.GetSelectedFieldValues(GridServiceAcceptance.cpKeyfield, GetSelectedFieldValuesCallback);
        CheckAllCount = GridServiceAcceptance.cpVisibleRowCount
        //console.log(CheckAllCount);
        CheckAllCountChange = GridServiceAcceptance.GetSelectedRowCount();

        //if(CheckAllCountChange == CheckAllCount)
        //{
        //    CheckAll.SetValue(true);
        //}
        //else
        //{
        //    CheckAll.SetValue(false);
        //}


        //GridServiceAcceptance.PerformCallback();

        parameterList = "";
        counter = 0;

        //            for (var index = GridServiceAcceptance.cpStartIndex; index < GridServiceAcceptance.cpEndIndex; index++) {
        //                if(GridServiceAcceptance.cpIsRowSelected[index]==true)
        //                {
        //                    parameterList += GridServiceAcceptance.cpDeliveryNo[index];
        //                    parameterList += ",";
        //                }
        //                counter++;

        //                if (CheckAll.GetChecked())
        //                {
        //                    //console.log(index);
        //                    parameterList += GridServiceAcceptance.cpDeliveryNo[index];
        //                    parameterList += ",";
        //                    counter++;
        //                }
        //                else
        //                {
        //                   // console.log(index);
        //                    if (GridServiceAcceptance.IsRowSelectedOnPage(index)) {
        //                        parameterList += GridServiceAcceptance.cpDeliveryNo[index];
        //                        parameterList += ",";
        //                        counter++;
        //                        console.log(parameterList);
        //                    }
        //                }
        // }




    }
    var toggle = 1;
    function ToggleDetail(s, e){
        GridServiceAcceptance.PerformCallback('ToggleColumns=FINANCIAL_DOCUMENT;SUPPLIER_INVOICE;CANCELLATION');
        if(toggle == 1)
        {
            btnToggle.SetText("Hide Detail");
            toggle = 0;
        }
        else{
            btnToggle.SetText("Show Detail");
            toggle = 1;
        }

    }

    function openpop(v)
    {
        DeliveryNo = v;
        //console.log(v);
        GridServiceAcceptanceDetail.PerformCallback();
        popupnew.SetHeaderText('Detail Service Acceptance');
        popupnew.Show();
    }

    function detailError(v)
    {
        DeliveryNo = v

        GridServiceAcceptanceDetailError.PerformCallback();
        errorDetail.SetHeaderText('Error Posting Detail');
        errorDetail.Show();

    }

    function OnGetSelectedFieldValues(selectedValues)
    {
        var juj = juju.GetText();
        //popupnew.SetHeaderText('Detail Service Acceptance');
        // popupnew.Show();
        var items = "";
        if(selectedValues.length == 0) return;
        for(i = 0; i < selectedValues.length; i++) {
            items = items + selectedValues[i] + ";"
        }
        juju.SetText(items.substring(0,items.length - 1));
        if(juj!=items.substring(0,items.length - 1))
        {
            GridServiceAcceptanceDetail.ClearFilter();
        }

        if(juju.GetText()!="")
        {
            $('#toggleDetail').show();
        }
        else
        {
            $('#toggleDetail').hide();
        }

    }

    function OnBeginCallbackGridDetail(s, e) {
        //e.customArgs["DeliveryNo"] = juju.GetText();
        e.customArgs["DeliveryNo"] = DeliveryNo;
        DeliveryNo = "";
    }


    function getDeliveryNo()
    {

        var isInvoiced = false;
        

        var counter = 0;
        for (var index = GridServiceAcceptance.cpStartIndex; index < GridServiceAcceptance.cpEndIndex; index++) {
            if(GridServiceAcceptance.cpIsRowSelected[index]==true){
                parameterList += GridServiceAcceptance.cpDeliveryNo[index];
                parameterList += ",";
                if(GridServiceAcceptance.cpDeliverySts[index]=="Posted" && GridServiceAcceptance.cpInvoiceNo[index]!=null)
                {
                    isInvoiced=true;
                }
            }
            counter++;
        }

        if(approveProcess==true)
        {
            approveProcess=false;
            setApprove();
        }


        if(cancelProcess==true)
        {
            if(isInvoiced==true)
            {
                $.msgBox({ title: "error", type:"error", content:"some data has been invoice created, please cancel the invoice first." });
            }
            else
            {
                setCancel();
                //console.log('canceling');
            }
            cancelProcess=false;
            
        }

    }

    function approve(s, e) {
        parameterList = '';
        var errData = 0;
        if(CheckAll.GetValue()==false)
        {
            isApprove = "T";
            approveProcess = true;
            GridServiceAcceptance.PerformCallback();
        }
        else
        {
            //add fid.deny 2015-08-12 [start]
            //if checkall = true, then check status on grid only, if every status of checked delivery_no are allowed, then dont use the search parameter
            vGridKeyfield = "";
            tempKeyfield = "";
            for (var index = GridServiceAcceptance.GetTopVisibleIndex(); index < ((GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize) + GridServiceAcceptance.GetVisibleRowsOnPage()); index++) {
                if (GridServiceAcceptance.IsRowSelectedOnPage(index)) {
                    tempKeyfield = GridServiceAcceptance.cpDeliverySts[index - (GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize)];
                    if(vGridKeyfield.indexOf(tempKeyfield) < 0){
                        vGridKeyfield += GridServiceAcceptance.cpDeliverySts[index - (GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize)] + ",";
                    }
                }
            }
            //add fid.deny 2015-08-12 [end]

            /*var st = StatusOption.GetValue();
            st = st.split(';');
            for(i=0;i<st.length;i++)
            {
                if(st[i]=='Delivered' || st[i]=='Error Posting' || st[i]=='Canceled')
                {
                    
                }
                else
                {
                    errData = 1;
                }
            }*/

            //add fid.deny 2015-08-12 [start]
            vGridKeyfield = vGridKeyfield.substring(0, vGridKeyfield.length - 1);
            var cst = vGridKeyfield.split(',');
            for(j=0;j<cst.length;j++){
                if(cst[j]==='Delivered' || cst[j]==='Error Posting' || cst[j]==='Canceled')
                {
                
                }
                else
                {
                    errData = 1; 
                }
            }
            //add fid.deny 2015-08-12 [end]

            if(errData==0)
            {
                setApprove();
            }
            else{
                $.msgBox({ title: "error", type:"error", content:"Service acceptance cannot be approved, only if delivery status is delivered, Error Posting and canceled." });
            }
            
        }
    }

    function setApprove()
    {
        parameterList = parameterList.substring(0, parameterList.length - 1);
        var dn = '';
        if(CheckAll.GetValue()==true)
        {
            dn = DELIVERY_NO.GetText();
        }
        else{
            dn = parameterList;
        }

        //add fid.deny 2015-08-12 [start]
        vGridKeyfield = "";
        tempKeyfield = "";
        for (var index = GridServiceAcceptance.GetTopVisibleIndex(); index < ((GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize) + GridServiceAcceptance.GetVisibleRowsOnPage()); index++) {
            if (GridServiceAcceptance.IsRowSelectedOnPage(index)) {
                tempKeyfield = GridServiceAcceptance.cpDeliverySts[index - (GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize)];
                if(vGridKeyfield.indexOf(tempKeyfield) < 0){
                    vGridKeyfield += GridServiceAcceptance.cpDeliverySts[index - (GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize)] + ";";
                }
            }
        }
        vGridKeyfield = vGridKeyfield.substring(0, vGridKeyfield.length - 1);
        //add fid.deny [end]


        if(parameterList!="" || CheckAll.GetValue()==true)
        {
            $.ajax(
              {
                type: "POST",
                url: "@Url.Content("~/D31301/SetApprove")",
                data:{
                DeliveryNo : dn,
                DeliveryType : DeliveryTypeOption.GetText(),
                LogisticPartner : LogisticPartnerOption.GetText(),
                Route : RouteOption.GetText(),
                Status : vGridKeyfield,//chenged fid.deny 2015-08-12, was Status : StatusOption.GetText(),
                RouteDate : ROUTE_DATE.GetText(),
                RouteDateTo : ROUTE_DATE_TO.GetText(),
                PoNo : PO_NO.GetText(),
                CheckAll : CheckAll.GetValue()
                },
                success: function (result) {
                GridServiceAcceptance.Refresh();
                if(result.data[0].TYPE == "WRN")
                {
                    $.msgBox({ title: "error", type:"error", content:result.data[0].MESSAGE });
                    GridServiceAcceptance.UnselectRows();
                }
                else
                {
                    $.msgBox({ title: "info", type:"info", content:result.data[0].MESSAGE });
                    GridServiceAcceptance.UnselectRows();
                }

            }
        });
            CheckAll.SetValue(false);
        GridServiceAcceptance.UnselectAllRowsOnPage();
        DeliveryNo = "";
        parameterList = "";
    }
    else
    {
            $.msgBox({ title: "Warning", type:"alert", content:"Please select item to approve!" });
    }

        GridServiceAcceptance.UnselectRows();
    }



    function cancel(s, e) {
        parameterList = '';
        var errData = 0;
        if(CheckAll.GetValue()==false)
        {
            isCancel = "T";
            cancelProcess = true;
            GridServiceAcceptance.PerformCallback();
        }
        else
        {

            //var st = StatusOption.GetValue();
            //st = st.split(';');
            //for(i=0;i<st.length;i++)
            //{
            //    if(st[i]!='Posted')
            //    {
            //        errData = 1;
            //    }
            //}

            vGridKeyfield = "";
            tempKeyfield = "";
            for (var index = GridServiceAcceptance.GetTopVisibleIndex(); index < ((GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize) + GridServiceAcceptance.GetVisibleRowsOnPage()); index++) {
                if (GridServiceAcceptance.IsRowSelectedOnPage(index)) {
                    tempKeyfield = GridServiceAcceptance.cpDeliverySts[index - (GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize)];
                    if(vGridKeyfield.indexOf(tempKeyfield) < 0){
                        vGridKeyfield += GridServiceAcceptance.cpDeliverySts[index - (GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize)] + ",";
                    }
                }
            }

            vGridKeyfield = vGridKeyfield.substring(0, vGridKeyfield.length - 1);
            var cst = vGridKeyfield.split(',');
            for(j=0;j<cst.length;j++){
                if(cst[j]!=='Posted')
                {
                    errData = 1;
                    break;
                }
            }

            if(errData==0)
            {
                
                var isInvoiced = false;
                var counter = 0;
                for (var index = GridServiceAcceptance.cpStartIndex; index < GridServiceAcceptance.cpEndIndex; index++) {
                    if(GridServiceAcceptance.cpIsRowSelected[index]==true){
                        if(GridServiceAcceptance.cpDeliverySts[index]=="Posted" && GridServiceAcceptance.cpInvoiceNo[index]!=null)
                        {
                            isInvoiced=true;
                        }
                    }
                    counter++;
                }

                if(isInvoiced==true)
                {
                    $.msgBox({ title: "error", type:"error", content:"some data has been invoice created, please cancel the invoice first." });
                }
                else
                {
                    setCancel();
                    //console.log('cancelings');
                }
                
            }
            else{
                $.msgBox({ title: "error", type:"error", content:"Service acceptance cannot be cancel, only if delivery status is Posted." });
            }
            
        }
    }

    function setCancel()
    {
        parameterList = parameterList.substring(0, parameterList.length - 1);
        var dn = '';
        if(CheckAll.GetValue()==true)
        {
            dn = DELIVERY_NO.GetText();
        }
        else{
            dn = parameterList;

        }

        vGridKeyfield = "";
        tempKeyfield = "";
        for (var index = GridServiceAcceptance.GetTopVisibleIndex(); index < ((GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize) + GridServiceAcceptance.GetVisibleRowsOnPage()); index++) {
            if (GridServiceAcceptance.IsRowSelectedOnPage(index)) {
                tempKeyfield = GridServiceAcceptance.cpDeliverySts[index - (GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize)];
                if(vGridKeyfield.indexOf(tempKeyfield) < 0){
                    vGridKeyfield += GridServiceAcceptance.cpDeliverySts[index - (GridServiceAcceptance.GetPageIndex() * GridServiceAcceptance.cpPageSize)] + ",";
                }
            }
        }

        if(parameterList!="" || CheckAll.GetValue()==true)
        {
            $.ajax(
              {
                  type: "POST",
                  url: "@Url.Content("~/D31301/SetCancel")",
                  data:{
                  DeliveryNo : dn,
                  DeliveryType : DeliveryTypeOption.GetText(),
                  LogisticPartner : LogisticPartnerOption.GetText(),
                  Route : RouteOption.GetText(),
                  Status : vGridKeyfield.substr(0, vGridKeyfield.length - 1),//StatusOption.GetText(),
                  RouteDate : ROUTE_DATE.GetText(),
                  RouteDateTo : ROUTE_DATE_TO.GetText(),
                  PoNo : PO_NO.GetText(),
                  CheckAll : CheckAll.GetValue()
                },
            success: function (result) {
                GridServiceAcceptance.Refresh();
                if(result.data[0].TYPE == "WRN")
                {
                    $.msgBox({ title: "error", type:"error", content:result.data[0].MESSAGE });
                    GridServiceAcceptance.UnselectRows();
                }
                else
                {
                    $.msgBox({ title: "info", type:"info", content:result.data[0].MESSAGE });
                    GridServiceAcceptance.UnselectRows();
                }

            }
        });
        CheckAll.SetValue(false);
        GridServiceAcceptance.UnselectAllRowsOnPage();
        DeliveryNo = "";
        parameterList = "";
    }
    else
    {
            $.msgBox({ title: "Warning", type:"alert", content:"Please select item to cancel!" });
    }

        GridServiceAcceptance.UnselectRows();
    }

    @*function cancel(s, e) {

        parameterList = '';
        var errData = 0;
        if(CheckAll.GetValue()==false)
        {
            isCancel = "T";
            cancelProcess = true;
            GridServiceAcceptance.PerformCallback();
        }
        else
        {
            var st = StatusOption.GetValue();
            st = st.split(';');
            for(i=0;i<st.length;i++)
            {
                if(st[i]!='Posted')
                {
                    errData = 1;
                }
            }

            if(errData==0)
            {
                setCancel();
            }
            else{
                $.msgBox({ title: "error", type:"error", content:"Service acceptance cannot be canceled, only if delivery status is Posted." });
            }
        }
    }



    function setCancel()
    {
        alert(CheckAll.GetValue());
        parameterList = parameterList.substring(0, parameterList.length - 1);
        var dn = '';
        if(CheckAll.GetValue()==true)
        {
            dn = DELIVERY_NO.GetText();
        }
        else{
            dn = parameterList;

        }

        if(parameterList!="")
        {
            $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31301/SetCancel")",
                data:{DeliveryNo : parameterList},
                success: function (result) {
                    GridServiceAcceptance.Refresh();
                    if(result.data[0].TYPE == "WRN")
                    {
                         $.msgBox({ title: "Warning", type:"alert", content:result.data[0].MESSAGE });
                    }
                    else
                    {
                         $.msgBox({ title: "info", type:"info", content:result.data[0].MESSAGE });
                    }
                }
            });
            CheckAll.SetChecked(false);
            GridServiceAcceptance.UnselectAllRowsOnPage();
            DeliveryNo = "";
        }
        else
        {
                $.msgBox({ title: "Warning", type:"alert", content:"Please select record to be cancel" });
        }
    }

        *@


    function setMindate()
    {
        //ROUTE_DATE_TO.SetMinDate = ROUTE_DATE.GetDate();

        // console.log(ROUTE_DATE.GetDate());
    }

    function OnPartInfoOkButtonClick()
    {
        dialog.Hide();
    }


    function StatusCheck(s,e)
    {
        var selectedValues = GridServiceAcceptance.cpDeliveryNo;
        var sv = "";
        for (var i = 0; i < selectedValues.length; i++) {
            //e.customArgs["DELIVERY_NO"] += selectedValues[i] + ',';
            //console.log(selectedValues[i]);
            sv+=selectedValues[i]+'-';
        }
        sv = sv.substring(0,sv.length-1);
        $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31301/SetApprove")",
                data:
                {
                    Status : sv
                },
                dataType:"JSON",
                success: function (result) {
                    // console.log(result);
                    //alert(result.data[0].STATUS);
                    /*if(result.data[0].TYPE == "WRN")
                    {
                        dialog.SetHeaderText('Warning');
                        $('#icono').html('<img width="32" src="@Url.Content("~/Content/images/warning_icon.png")" />');
                }
            else
        {
                        dialog.SetHeaderText('Info');
        $('#icono').html('<img width="32" src="@Url.Content("~/Content/images/info_icon.png")" />');
    }
    message.textContent = result.data[0].MESSAGE;
    dialog.Show();
    */
    }
    });

    }





    function trims(str) {
        return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
    }

    function saveNotes(index)
    {
        var isError1 = 0;
        var isError2 = 0;
        var isError3 = 0;
        var isError4 = 0;

        var DN = GridServiceAcceptance.cpDeliveryNo[index];
        var N = window["txtSA_Notes["+index+"]"].GetText();
        
        var a = N.split(".");
        var b = N.split(",");
        var c = N.split("?");
        var d = N.split("!");


        for(i=0;i<a.length-1;i++)
        {
            if(a[i].length==0)
            {
                isError1=1;
            }
        }

        for(i=0;i<b.length-1;i++)
        {
            if(b[i].length==0)
            {
                isError2=1;
            }
        }

        for(i=0;i<c.length-1;i++)
        {
            if(c[i].length==0)
            {
                isError3=1;
            }
        }

        for(i=0;i<d.length-1;i++)
        {
            if(d[i].length==0)
            {
                isError4=1;
            }
        }


        if(N=="" || trims(N)=="" || isError1==1 || isError2==1 || isError3==1 || isError4==1)
        {
            $.msgBox({ title: "Warning", type:"alert", content:"Please fill the note" });
            window["txtSA_Notes["+index+"]"].SetText("");
        }
        else
        {

            $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31301/saveNotes")",
                data:
                {
                    DeliveryNo : DN,
                    Notes : N
                },
                dataType:"JSON",
                success: function (result) {
                    if (result.status == 'success')
                        $.msgBox({ title: "Info", type:"info", content:result.message });
                    else
                        $.msgBox({ title: "Warning", type:"warning", content:result.message });

                    GridServiceAcceptance.ClearFilter();
                }
            });

        }

    }

</script>

@*<div style="width:1124px;padding-right:0px; padding-bottom:15px; ">
        <table width="100%">
            <tr>
                <td style="border:1px solid #142B94;background-color:#DEECFD;padding:10px;">
                    @Html.Action("PartialHeader", "RouteMaster")
                </td>
            </tr>
            <tr style="height:5px;"></tr>
            <tr>
                <td>
                    @Html.Partial("PartialRouteDatas", "RouteMaster")
                </td>
            </tr>
        </table>
    </div>*@

<div style="display: table; border: 1px solid #142B94; background-color: #DEECFD;
    padding: 10px; ">
    @Html.Action("PartialHeader", "D31301")
</div>
<div style="height: 15px;">
</div>
@* div spacing *@
<div>
    @Html.Action("PartialDatas", "D31301")
</div>


<div id="toggleDetail" style="margin-top:5px;"></div>
@Html.DevExpress().PopupControl(
    settings =>
    {
        settings.Name = "dialog";
        settings.ShowHeader = false;
        settings.Width = System.Web.UI.WebControls.Unit.Pixel(250);
        settings.Height = System.Web.UI.WebControls.Unit.Pixel(140);
        settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
        settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
        settings.Modal = true;
        settings.ShowHeader = true;
        settings.ShowCloseButton = false;
        settings.CloseAction = CloseAction.CloseButton;
        settings.SetContent(() =>
        {
            Html.RenderPartial("dialog");
        });
    }).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Name = "popupnew";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(400);
    //settings.Height = System.Web.UI.WebControls.Unit.Pixel(350);
    settings.Modal = true;
    settings.ShowPageScrollbarWhenModal = false;
    settings.CloseAction = CloseAction.CloseButton;
    settings.SetContent(() =>
    {
        Html.RenderPartial("GridIndexDetail");
    });
}).GetHtml()



@Html.DevExpress().PopupControl(settings =>
{
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Name = "errorDetail";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(900);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(350);
    settings.Modal = true;
    settings.ShowPageScrollbarWhenModal = false;
    settings.CloseAction = CloseAction.CloseButton;
    settings.SetContent(() =>
    {
        Html.RenderPartial("GridIndexDetailError");
    });
}).GetHtml()